import { Decoder } from 'io-ts';
import { FSEntity } from './utils/fs';
import { taskEither } from 'fp-ts';
import { Either } from 'fp-ts/lib/Either';
import { ResolveRefContext } from './utils/ref';
import { Reader } from 'fp-ts/lib/Reader';
export interface Language<A> {
    (documents: Record<string, A>): Either<unknown, FSEntity>;
}
export interface GenerateOptions<A> {
    readonly cwd?: string;
    readonly out: string;
    readonly spec: string;
    readonly decoder: Decoder<unknown, A>;
    readonly language: Reader<ResolveRefContext, Language<A>>;
}
export declare const generate: <A>(options: GenerateOptions<A>) => taskEither.TaskEither<unknown, void>;
