"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const schema_object_1 = require("./schema-object");
const serialized_type_1 = require("../../common/data/serialized-type");
const Either_1 = require("fp-ts/lib/Either");
const pipeable_1 = require("fp-ts/lib/pipeable");
const fp_ts_1 = require("fp-ts");
const ref_1 = require("../../../../utils/ref");
const reference_object_1 = require("../../../../schema/3.0/reference-object");
exports.serializeRequestBodyObject = (from, body) => pipeable_1.pipe(getSchema(body), fp_ts_1.either.chain(schema => reference_object_1.ReferenceObjectCodec.is(schema)
    ? pipeable_1.pipe(schema.$ref, ref_1.fromString, Either_1.mapLeft(() => new Error(`Invalid MediaObject.content.$ref "${schema.$ref}" for RequestBodyObject`)), fp_ts_1.either.map(serialized_type_1.getSerializedRefType(from)))
    : schema_object_1.serializeSchemaObject(from)(schema)));
const getSchema = (requestBodyObject) => pipeable_1.pipe(fp_ts_1.record.lookup('application/json', requestBodyObject.content), fp_ts_1.option.chain(media => media.schema), fp_ts_1.either.fromOption(() => new Error('No schema found for ReqeustBodyObject')));
