"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const serialized_type_1 = require("../../common/data/serialized-type");
const pipeable_1 = require("fp-ts/lib/pipeable");
const schema_object_1 = require("./schema-object");
const ref_1 = require("../../../../utils/ref");
const fp_ts_1 = require("fp-ts");
const reference_object_1 = require("../../../../schema/3.0/reference-object");
exports.serializeResponseObject = (from, responseObject) => pipeable_1.pipe(responseObject.content, fp_ts_1.option.mapNullable(content => content['application/json']), fp_ts_1.option.chain(media => media.schema), fp_ts_1.option.map(schema => reference_object_1.ReferenceObjectCodec.is(schema)
    ? pipeable_1.pipe(ref_1.fromString(schema.$ref), fp_ts_1.either.map(serialized_type_1.getSerializedRefType(from)))
    : schema_object_1.serializeSchemaObject(from)(schema)));
