"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const serialized_type_1 = require("../../common/data/serialized-type");
const utils_1 = require("../../common/utils");
const pipeable_1 = require("fp-ts/lib/pipeable");
const response_object_1 = require("./response-object");
const serialized_dependency_1 = require("../../common/data/serialized-dependency");
const array_1 = require("../../../../utils/array");
const either_utils_1 = require("@devexperts/utils/dist/adt/either.utils");
const fp_ts_1 = require("fp-ts");
const ref_1 = require("../../../../utils/ref");
const Option_1 = require("fp-ts/lib/Option");
const reference_object_1 = require("../../../../schema/3.0/reference-object");
exports.serializeResponsesObject = (from) => (responsesObject) => {
    const serializedResponses = pipeable_1.pipe(utils_1.SUCCESSFUL_CODES, fp_ts_1.array.map(code => pipeable_1.pipe(fp_ts_1.record.lookup(code, responsesObject), fp_ts_1.option.chain(r => reference_object_1.ReferenceObjectCodec.is(r)
        ? pipeable_1.pipe(ref_1.fromString(r.$ref), fp_ts_1.either.mapLeft(() => new Error(`Invalid ${r.$ref} for ResponsesObject'c code "${code}"`)), fp_ts_1.either.map(serialized_type_1.getSerializedRefType(from)), Option_1.some)
        : response_object_1.serializeResponseObject(from, r)))), fp_ts_1.array.compact, either_utils_1.sequenceEither, fp_ts_1.either.map(serialized_type_1.uniqSerializedTypesByTypeAndIO));
    return pipeable_1.pipe(serializedResponses, fp_ts_1.either.map(serializedResponses => {
        if (serializedResponses.length === 0) {
            return serialized_type_1.SERIALIZED_VOID_TYPE;
        }
        const combined = serialized_type_1.intercalateSerializedTypes(serialized_type_1.serializedType('|', ',', [], []), serializedResponses);
        const isUnion = serializedResponses.length > 1;
        return serialized_type_1.serializedType(combined.type, isUnion ? `union([${combined.io}])` : combined.io, array_1.concatIfL(isUnion, combined.dependencies, () => [serialized_dependency_1.serializedDependency('union', 'io-ts')]), []);
    }));
};
